package com.engine.salary.mapper.salaryitem;

import com.engine.salary.entity.salaryitem.param.SalaryItemSearchParam;
import com.engine.salary.entity.salaryitem.po.SalaryItemPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface SalaryItemMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<SalaryItemPO> listAll();


	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	SalaryItemPO getById(Long id);

	/**
	 * 条件查询
	 *
	 * @return 返回集合，没有返回空List
	 */
	List<SalaryItemPO> listSome(SalaryItemPO salaryItem);
	
	/**
     * 新增，忽略null字段
     *
     * @param SalaryItemPO 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(SalaryItemPO SalaryItemPO);

	
	/**
     * 修改，忽略null字段
     *
     * @param SalaryItemPO 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(SalaryItemPO SalaryItemPO);
	
	/**
     * 删除记录
     *
     * @param SalaryItemPO 待删除的记录
     * @return 返回影响行数
     */
	int delete(SalaryItemPO SalaryItemPO);

	void batchInsert(Collection<SalaryItemPO> salaryItems);

	void deleteByIds(@Param("ids") Collection<Long> ids);

	List<SalaryItemPO> listByParam(@Param("param") SalaryItemSearchParam param);

	List<SalaryItemPO> listByParamOrderById(@Param("param") SalaryItemSearchParam param);

	void batchUpdateSortedIndex(@Param("collection")List<SalaryItemPO> salaryItemPOS);


}